Attribute VB_Name = "MemoryCopy"
Option Explicit

Public Declare Sub memcpy _
                Lib "kernel32" _
                Alias "RtlMoveMemory" _
                (dest As Any, src As Any, ByVal count As Long)
Public Sub ByteArrayCopy(Destination() As Byte, Source() As Byte)
    Dim count As Long
    Dim LB As Long, UB As Long
    Dim dest As Long
    
    LB = LBound(Source)
    UB = UBound(Source)
    
    ReDim Destination(LB To UB)
    count = UB - LB + 1
    memcpy Destination(LB), Source(LB), count
End Sub

Public Sub ByteArrayConnect(Destination() As Byte, AddData() As Byte)
    On Error GoTo ErrorHandler:
    
    Dim count As Long
    Dim LBA As Long, UBA As Long
    Dim LBD As Long, UBD As Long
    Dim dest As Long
    
    LBA = LBound(AddData)
    UBA = UBound(AddData)
    
    LBD = LBound(Destination)
    UBD = UBound(Destination)
    
    count = UBA - LBA + 1
    ReDim Preserve Destination(LBD To UBD + count)
    memcpy Destination(UBD + 1), AddData(LBA), count
    
    Exit Sub
    
ErrorHandler:
    ReDim Destination(0)
    Resume
End Sub
