Attribute VB_Name = "StandardIO"
Option Explicit

Private Declare Function GetStdHandle _
                        Lib "kernel32" _
                        (ByVal nStdHandle As Long) As Long
Public Const STD_INPUT_HANDLE As Long = -10&
Public Const STD_OUTPUT_HANDLE As Long = -11&
Public Const STD_ERROR_HANDLE As Long = -12&

Private Declare Function ReadFile _
                        Lib "kernel32" _
                        (ByVal hFile As Long, _
                         lpBuffer As Any, _
                         ByVal lpNumberOfBytesRead As Long, _
                         lpOverlapped As Any) _
                        As Long
    
Private Declare Function WriteFile _
                        Lib "kernel32" _
                        (ByVal hFile As Long, _
                         lpBuffer As Any, _
                         ByVal nNumberOfBytesToWrite As Long, _
                         lngBytesWritten As Long, _
                         ByVal lpOverlapped As Long) _
                        As Long

Public Function SendANSIText(ByVal strBuffer As String) As Long
    Dim bytBuffer() As Byte
    
    bytBuffer = StrConv(strBuffer, vbFromUnicode)
    SendANSIText = SendByte(bytBuffer)

End Function

Public Function SendByte(bytBuffer() As Byte) As Long
    Dim lngBufferBase As Long
    Dim lngBytesToWrite As Long, lngBytesWritten As Long
    
    Dim lngRetCode As Long
    Dim hStdOut As Long
    
    lngBufferBase = LBound(bytBuffer)
    lngBytesToWrite = UBound(bytBuffer) - lngBufferBase + 1
    
    hStdOut = GetStdHandle(STD_OUTPUT_HANDLE)
    lngRetCode = WriteFile(hStdOut, _
                            bytBuffer(lngBufferBase), _
                            lngBytesToWrite, _
                            lngBytesWritten, _
                            0&)
    
    If lngRetCode = 0 Or lngBytesToWrite <> lngBytesWritten Then
        SendByte = 0
    Else
        SendByte = lngBytesWritten
    End If
End Function
