Attribute VB_Name = "TempFileName"
Option Explicit

Private Const MAX_PATH As Long = 260

Private Declare Function GetTempFileNameAPI _
                            Lib "kernel32" _
                            Alias "GetTempFileNameA" _
                            (ByVal lpPathName As String, _
                             ByVal lpPrefixString As String, _
                             ByVal uUnique As Long, _
                             ByVal lpTempFileName As String) As Long

Public Function GetTempFileName(ByVal strPathName As String, _
                                ByVal strPrefixString As String) As Variant
    Dim lngRetCode As Long
    Dim strTempFileName As String
    
    strTempFileName = String$(MAX_PATH, vbNullChar)
    lngRetCode = GetTempFileNameAPI(strPathName, _
                                    strPrefixString, _
                                    0, _
                                    strTempFileName)
    If lngRetCode <> 0 Then
        GetTempFileName = Left(strTempFileName, _
                                    InStr(strTempFileName, vbNullChar) - 1)
    Else
        GetTempFileName = ""
    End If
End Function
