Attribute VB_Name = "Module1"
Option Explicit

Declare Function WNetConnectionDialog Lib "mpr" _
                    (ByVal hwnd As Long, _
                     ByVal dwType As Long) As Long

Declare Function WNetOpenEnum Lib "mpr" Alias "WNetOpenEnumA" _
                    (ByVal dwScope As Long, _
                     ByVal dwType As Long, _
                     ByVal dwUsage As Long, _
                     lpNetResource As Any, _
                     lphEnum As Any) As Long

Declare Function WNetCloseEnum Lib "mpr" _
                    (ByVal hEnum As Long) As Long

Declare Function WNetEnumResource Lib "mpr" Alias "WNetEnumResourceA" _
                    (ByVal hEnum As Long, _
                     lpcCount As Long, _
                     lpBuffer As Any, _
                     lpBufferSize As Long) As Long
                     
Public Type NETRESOURCE
    dwScope As Long
    dwType As Long
    dwDisplayType As Long
    dwUsage As Long
    lpLocalName As Long
    lpRemoteName As Long
    lpComment As Long
    lpProvider As Long
End Type

Public Type NETRESOURCE_STRING
    dwScope As Long
    dwType As Long
    dwDisplayType As Long
    dwUsage As Long
    lpLocalName As String
    lpRemoteName As String
    lpComment As String
    lpProvider As String
End Type

Public Const RESOURCETYPE_ANY As Long = &H0&
Public Const RESOURCETYPE_DISK As Long = &H1&
Public Const RESOURCETYPE_PRINT As Long = &H2&
Public Const RESOURCETYPE_RESERVED As Long = &H8&
Public Const RESOURCETYPE_UNKNOWN  As Long = &HFFFFFFFF

Public Const RESOURCEDISPLAYTYPE_GENERIC        As Long = &H0&
Public Const RESOURCEDISPLAYTYPE_DOMAIN         As Long = &H1&
Public Const RESOURCEDISPLAYTYPE_SERVER         As Long = &H2&
Public Const RESOURCEDISPLAYTYPE_SHARE          As Long = &H3&
Public Const RESOURCEDISPLAYTYPE_FILE           As Long = &H4&
Public Const RESOURCEDISPLAYTYPE_GROUP          As Long = &H5&
Public Const RESOURCEDISPLAYTYPE_NETWORK        As Long = &H6&
Public Const RESOURCEDISPLAYTYPE_ROOT           As Long = &H7&
Public Const RESOURCEDISPLAYTYPE_SHAREADMIN     As Long = &H8&
Public Const RESOURCEDISPLAYTYPE_DIRECTORY      As Long = &H9&
Public Const RESOURCEDISPLAYTYPE_TREE           As Long = &HA&
Public Const RESOURCEDISPLAYTYPE_NDSCONTAINER   As Long = &HB&

Public Const RESOURCE_CONNECTED As Long = &H1&
Public Const RESOURCE_GLOBALNET As Long = &H2&
Public Const RESOURCE_REMEMBERED As Long = &H3&
Public Const RESOURCE_RECENT As Long = &H4&
Public Const RESOURCE_CONTEXT As Long = &H5&

Public Const RESOURCEUSAGE_CONNECTABLE As Long = &H1&
Public Const RESOURCEUSAGE_CONTAINER As Long = &H2&
Public Const RESOURCEUSAGE_NOLOCALDEVICE As Long = &H4&
Public Const RESOURCEUSAGE_SIBLING As Long = &H8&
Public Const RESOURCEUSAGE_ATTACHED As Long = &H10&
Public Const RESOURCEUSAGE_ALL As Long = RESOURCEUSAGE_CONNECTABLE _
                                            + RESOURCEUSAGE_CONTAINER _
                                            + RESOURCEUSAGE_ATTACHED
Public Const RESOURCEUSAGE_RESERVED As Long = &H80000000
