Attribute VB_Name = "DllDelcaration"
Private Declare Function sndPlaySound Lib "winmm" _
                    Alias "sndPlaySoundA" _
                    (ByVal lpszSoundName As Long, _
                     ByVal uFlags As Long) _
                    As Long

Public Const SND_SYNC As Long = &H0&
Public Const SND_ASYNC As Long = &H1&

Public Const SND_NODEFAULT As Long = &H2&
Public Const SND_MEMORY As Long = &H4&
Public Const SND_LOOP As Long = &H8&
Public Const SND_NOSTOP As Long = &H10&

Public Const SNDBUILTIN_DEFAULT As String = ".Default"
Public Const SNDBUILTIN_APPGPFAULT As String = "AppGPFault"
Public Const SNDBUILTIN_CLOSE As String = "Close"
Public Const SNDBUILTIN_OPEN As String = "Open"
Public Const SNDBUILTIN_MAILBEEP As String = "MailBeep"
Public Const SNDBUILTIN_MAXIMIZE As String = "Maximize"
Public Const SNDBUILTIN_MINIMIZE As String = "Minimize"
Public Const SNDBUILTIN_MENUCOMMAND As String = "MenuCommand"
Public Const SNDBUILTIN_MENUPOPUP As String = "MenuPopup"
Public Const SNDBUILTIN_RESTOREDOWN As String = "RestoreDown"
Public Const SNDBUILTIN_RESTOREUP As String = "RestoreUp"

Public Const SNDBUILTIN_SYSASTERISK As String = "SystemAsterisk"
Public Const SNDBUILTIN_SYSDEFAULT As String = "SystemDefault"
Public Const SNDBUILTIN_SYSEXCLAMATION As String = "SystemExclamation"
Public Const SNDBUILTIN_SYSEXIT As String = "SystemExit"
Public Const SNDBUILTIN_SYSHAND As String = "SystemHand"
Public Const SNDBUILTIN_SYSQUESTION As String = "SystemQuestion"
Public Const SNDBUILTIN_SYSSTART As String = "SystemStart"

Public Function PlaySound(ByVal strWavName As String, _
                          ByVal uFlags As Long) As Boolean
    strWavName = StrConv(strWavName, vbFromUnicode)
    PlaySoundWAVFile = sndPlaySound(StrPtr(strWavName), uFlags)
End Function

Public Function PlaySoundInArray(bytWavData() As Byte, _
                                ByVal uFlags As Long) As Boolean
    Dim lngBase As Long
    
    On Error GoTo ErrorHandler:
    
    lngBase = LBound(bytWavData)
    uFlags = uFlags Or SND_MEMORY
    
    PlaySoundInArray = sndPlaySound(VarPtr(bytWavData(lngBase)), uFlags)
    Exit Function
    
ErrorHandler:
    PlaySoundInArray = False
End Function

Public Function PlaySoundSTOP() As Boolean
    PlaySoundSTOP = sndPlaySound(0, SND_ASYNC)
End Function
