Attribute VB_Name = "GetString"
Option Explicit

Private Declare Function SysAllocStringByteLen _
                        Lib "oleaut32" _
                        (ByVal psz As Long, _
                         ByVal length As Long) _
                        As String

Private Declare Function lstrlenA _
                        Lib "kernel32" _
                        (ByVal lpString As Long) _
                        As Long

Private Declare Function lstrlenW _
                        Lib "kernel32" _
                        (ByVal lpString As Long) _
                        As Long

Private Declare Sub RtlMoveMemory _
                        Lib "kernel32" _
                        (ByVal dest As Long, _
                         ByVal src As Long, _
                         ByVal count As Long)
                
Public Function GetANSIStringAt(ByVal sz As Long) As String
    Dim lngLengthByte As Long
    
    If sz = 0 Then
        GetANSIStringAt = vbNullString
    Else
        lngLengthByte = lstrlenA(sz)
        If lngLengthByte = 0 Then
            GetANSIStringAt = ""
        Else
            GetANSIStringAt = SysAllocStringByteLen(sz, lngLengthByte)
        End If
    End If
End Function

Public Function GetUNICODEStringAt(ByVal sz As Long) As String
    Dim lngLengthChar As Long

    If sz = 0 Then
        GetUNICODEStringAt = vbNullString
    Else
        lngLengthChar = lstrlenW(sz)
        If lngLengthChar = 0 Then
            GetUNICODEStringAt = ""
        Else
            GetUNICODEStringAt = String$(lngLengthChar, vbNullChar)
            RtlMoveMemory StrPtr(GetUNICODEStringAt), sz, lngLengthChar * 2
        End If
    End If
End Function

Public Function SetSZtoArrayA(ByVal strInput As String, bytOutput() As Byte)
    Dim lngLengthByte As Long
    
    If strInput = "" Then
        ReDim bytOutput(0 To 0)
        bytOutput(0) = 0
    Else
        lngLengthByte = LenB(strInput)
        ReDim bytOutput(0 To lngLengthByte)
        RtlMoveMemory VarPtr(bytOutput(0)), StrPtr(strInput), lngLengthByte
        bytOutput(lngLengthByte) = 0
    End If
End Function

Public Function SetSZtoArrayW(ByVal strInput As String, bytOutput() As Byte)
    Dim lngLengthByte As Long
    
    If strInput = "" Then
        ReDim bytOutput(0 To 1)
        bytOutput(0) = 0
        bytOutput(1) = 0
    Else
        lngLengthByte = LenB(strInput)
        ReDim bytOutput(0 To lngLengthByte + 1)
        RtlMoveMemory VarPtr(bytOutput(0)), StrPtr(strInput), lngLengthByte
        bytOutput(lngLengthByte) = 0
        bytOutput(lngLengthByte + 1) = 0
    End If
End Function
